<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>2-Way-Binding</title>
</head>

<body>
    Ettevõtte nimi: <br>
    <input type="text" data-bind="name"><br><br>

    Ettevõtte nimi: <br>
    <div data-bind="name"></div>

    <hr>

    Ettevõtte nimi: <br>
    <input type="text" data-bind="name"><br><br>

    <pre data-bind="name">

    </pre>

    Ettevõtte töötajate arv: <br>
    <input type="text" data-bind="employees"><br><br>

    <pre data-bind="employees">

    </pre>

    <script>
        let company = {
            name: 'Tallinna Sadam',
            employees: 450
        };

        let companyModel;

        function bindModel(model) {
            return new Proxy(model, {
                set: function (obj, propName, newValue) {
                    console.log('Property changed', obj, propName, newValue);
                    obj[propName] = newValue;
                    bindUiElements();
                }
            });
        }

        function updateModel(event) {
            let modelPropName = event.target.getAttribute('data-bind'); // name
            let newValue = event.target.value; // Microsoft
            companyModel[modelPropName] = newValue;
        }

        function bindInputs() {
            let inputs = document.querySelectorAll('[data-bind]');
            for (const input of inputs) {
                input.addEventListener('keyup', updateModel);
            }
        }

        function bindUiElements() {
            let uiElements = document.querySelectorAll('[data-bind]');

            for (const uiElement of uiElements) {
                let modelPropName = uiElement.getAttribute('data-bind'); // name
                let modelPropValue = companyModel[modelPropName];
                if (uiElement.nodeName === 'INPUT') {
                    uiElement.value = modelPropValue;
                } else {
                    uiElement.textContent = modelPropValue;
                }
            }
        }

        window.addEventListener('load', () => {
            companyModel = bindModel(company);
            bindInputs();
            bindUiElements();
        });

    </script>
</body>

</html>